%% CIS II Galen Kinematic Calibration 
%% Can Kocabalkanli, Spring 2020
%% Fit Bernstein polynomial to dataset
%% Can Kocabalkanli and Nicolas Lamaison; Programming Assignment 2 - ; CIS 1, Fall 2019

%%P and Q are Nu by 3 matrices where Nu = nframes*ntrackers (so all of our
%%expected and read data respectively from all frames. 
function [S] = get_coeffs(P,Q)

Nu = size(P, 1); %Total number of position vectors accross ALL frames in the data file
Fs = []; %The function F(s), for each individual position vector. Constitutes each row of F
F = []; %The Matrix of F
S = zeros(Nu, 3);
P_normalized = zeros(size(P,1), size(P,2));

%Order of the Bernstein Polynomial
o = 4;

%Get qmax and qmin as the vectors constituting of the largest and smallest 
%individual x, y, and z values 
qmax = [max(Q(:,1)) ; max(Q(:,2)) ; max(Q(:,3))]; %order reverse because of the way we defined P and Q
qmin = [min(Q(:,1)) ; min(Q(:,2)) ; min(Q(:,3))];

for s = 1: Nu
    %Scale every vector element
    u = ScaleToBox(Q(s,:), qmax, qmin);
    P_normalized(s,:) = ScaleToBox(P(s,:), qmax, qmin);
    for k = 1:(o+1) %K OR I LAST?
        for j = 1:(o+1)
            for i = 1:(o+1) %K OR I LAST?
                %Fs(i,j,k) = bern(5, (i-1), u(1))*bern(5, (j-1), u(2))*bern(5, (k-1), u(3));
                Fs = [Fs bern(o, (i-1), u(1))*bern(o, (j-1), u(2))*bern(o, (k-1), u(3))]; %this might be wrong
            end
        end
    end
    F = [F; Fs];
    Fs = [];
end
S = F\P_normalized;
end